#!/usr/bin/perl

use utf8;
use CGI;
use integer;
use POSIX;
use zfsearch;

zfsearch->read_config();
zfsearch->setup_gettext($ENV{"HTTP_ACCEPT_LANGUAGE"});

my $req = new CGI;
zfsearch->parse_params($req,\%params);
#zfsearch->log(\%params);

zfsearch->put_top(\%params,0);


my $x=$req->param('file');

my $f_ftype, $f_time, $f_sz, $f_proto, $f_path;
my $f_path_name=$f_path;
my $f_proto_mark;


if( length($x) != 0 ){
    my $found_url = 0;

    my $hash=0;
    my $fn=lc $x;
    while($fn =~ /(.)/g) {
        $hash = $hash * 37 + ord($1);
    }
    $hash= $hash%(997*2)+997*2;
    $hash = $hash % 997;

    my $begtime=time;
    open (SB, zfsearch->DATADIR."/hashfiles/$hash.idx") || die "No index file found: ".zfsearch->DATADIR."/hashfiles/$hash.idx";

    print "<a name=\'$x\'>$x:</a><P>";
    print "<table width=100% border=0 cellpadding=0 cellspacing=0>\n";
    print("<!-- <-$x/$hash-> -->\n");

    $lx=lc $x;
    
    $lx=~ s/\+/\\+/g;
    
    while(<SB>){ 
        chomp;
        if (substr($_,0,1) eq "#") {next;}
        if( /\/$lx$/io ){
            ($f_ftype, $f_time, $f_sz, $f_proto, $f_path) = split( /:/ );
            $f_path_name=$f_path;
            $f_proto_mark="";
            if($f_proto eq "smb"){
                $f_proto="file://";
                $f_proto_mark = "LAN";
            }
            if($f_proto eq "ftp"){
                $f_proto="ftp:";
                $f_proto_mark = "FTP";
            }
            #$f_path_name =~ s/\//\\/g;
            $f_path =~ s/\'/\\\'/g;
            print "\t<tr><td>$f_proto_mark</td><td><a href=\"$f_proto".$f_path."\">$f_path_name</a></td>";
            print "<td>" . $f_sz/1024 . "K</td><td>$f_time</td></tr>\n";
            ++$found_url;
        }
    }
    print "<tr><td colspan=2>";
    printf zfsearch->gettext("locations-found"),$found_url,$x;
    print "</td></tr>\n";
    print "</table><br><br>\n";
    close SB;
    
    my $tmsec=time-$begtime;
    printf zfsearch->gettext("timerefresh"),$tmsec;
}
else{
    printf zfsearch->gettext("no-files-found"),$x; 
}

zfsearch->put_skel_mode(zfsearch->SKELDIR,\%params);
zfsearch->put_bottom();
