#!/usr/bin/perl

use utf8;
use CGI;
use POSIX;
use zfsearch;
use integer;

zfsearch->read_config();
zfsearch->setup_gettext($ENV{"HTTP_ACCEPT_LANGUAGE"});

my $req = new CGI;
zfsearch->parse_params($req,\%params);
#zfsearch->log(\%params);


zfsearch->put_top(\%params,0);

my $portion_size = 100;

# Parsing input parameters
my $expr = lc $req->param('search');
my $query= $req->query_string();

my $mode = $req->param('mode');
my $tlit = $req->param('translit');

my $win32 = $req->param('win32');
my $arch = $req->param('arch');
my $install = $req->param('install');
my $doc = $req->param('doc');
my $src = $req->param('src');
my $video = $req->param('video');
my $audio = $req->param('audio');
my $all = $req->param('all');
my $custom = $req->param('custom');
my $extl = $req->param('exts');
my $imx = $req->param('imx');
my $jsp = $req->param('jsp');

my $d_win32 = $req->param('d_win32');
my $d_arch = $req->param('d_arch');
my $d_install = $req->param('d_install');
my $d_doc = $req->param('d_doc');
my $d_video = $req->param('d_video');
my $d_audio = $req->param('d_audio');

my $portion = $req->param('portion');
$portion = 0 if(length($portion)==0);

$all = 'Y' if ($custom =~ /A/ );
my $dir_expr = '';
my $org_expr = $expr;
my $org_exts = $extl;


if( length($expr) != 0 ){
    my $begtime=time;
    
    # common rules
    $expr =~ s:/:\\/:;
    #$expr =~ s/\$/\\\E\\\$\\\Q/;
    #$expr =~ s/\@/\\\E\\\@\\\Q/;
    $expr =~ s/\'/\\'/;
    
    my $s_dir_on = 1 if ($mode !~ 'R' && $all !~ 'Y');
    # Transforming parameters concerning checkbox states

    # mode = {S, R, E}

    # Easy mode - no substitutions here instead of * and ?
    if ($mode =~ 'E'){
        $expr=~s/\(/\\(/g;
        $expr=~s/\)/\\)/g;
        $expr=~s/\\/\\\\/g;
        $expr=~s/\./\./g;
        $expr=~s/\$/\\\$/g;
        $expr=~s/\|/\\|/g;
        $expr=~s/\[/\\[/g;
        $expr=~s/\]/\\]/g;
        $expr=~s/\+/\\+/g;
        
        # use user specified extension additionaly to predefined options
        if ($expr =~ /\.[\w\d\-_]+\$/ ) {
            my $tmp_extl = $expr;
            $tmp_extl =~ s/[^\.]+\.//g;
            $extl .= "\|$tmp_extl";
            $expr =~ s/\.[\w\d\-_]+\$//; 
        }

        $expr =~ s/\?/\[\\w\\s\\d\\-_\]/;
        $expr =~ s/\*/\[\\w\\s\\d\\-_\]\*/;
        $expr =~ s/\./\\./;

        $extl .= '|exe|dll|com|ocx|bin|drv|sys' if ($d_win32 =~ 'Y');
        $extl .= '|arj|ain|arc|lha|rar|hqx|zip|cpz|tgz|gz|bz2|uc2|cab|tar' if ($d_arch =~ 'Y');
        $extl .= '|exe|zip|tar.gz|cab|tar.bz2|bin|sh|deb|rpm' if ($d_install =~ 'Y');
        $extl .= '|doc|rtf|txt|html|htm|htx|chi|chm' if ($d_doc =~ 'Y');
        $extl .= '|avi|mpg|mpeg|mpeg2|dat|dv' if ($d_video =~ 'Y');
        $extl .= '|au|aiff|wav|raw|mp3|stm|s3m|xm|mod|mid|rmi|midi' if ($d_audio =~ 'Y');

        # crasy string concatenation to avoid nested substitution of \[wsd-] ;-)
        $dir_expr = "\^" . '[\w\s\d\-_]*(' . $expr . ")[^\.]*\$";
        $expr = "($expr)[^\.]*\.(gz$extl)\$";
    }

    # Smart mode - its own language parsing
    if ($mode =~ 'S'){
        $expr=~s/\(/\\(/g;
        $expr=~s/\)/\\)/g;
        $expr=~s/\\/\\\\/g;
        $expr=~s/\./\./g;
        $expr=~s/\$/\\\$/g;
        $expr=~s/\|/\\|/g;
        $expr=~s/\[/\\[/g;
        $expr=~s/\]/\\]/g;
        $expr=~s/\+/\\+/g;
        
        
        # Parsing command line
        $expr =~ s/\(/ \( /;
        $expr =~ s/\)/ \) /;
        $expr =~ s/ or / \| /;
        $expr =~ s/ and //;
        $expr =~ s/\./\\./;
        $expr =~ s/\*/\.\*/;

        my @words = split('[ \t]+', $expr);
        $expr = '';
        my $fst=1;
        my $lb = '';
        # replace or and andcommands to the regex pattern
        foreach my $x (@words) {
            $expr .= '[\w\-\s\d_]*' if($fst==0 && $x !~ /[\)\|]/ && $lb !~ /[\(\)\|]/);
            if ( $x =~ /[\(\)\|]/ ){ $expr .= $x; }
            else{ $expr .= "$x"; }
            $fst=0 if ($fst==1);
            $lb = $x;
        }
        # refine double sequences if exists
        $expr =~ s/\|\|/\|/g;
        $expr =~ s/\(\|/\(/g;
        $expr =~ s/\|\)/\)/g;

        # use user specified extension additionaly to predefined options
        if ($expr =~ /\.[\w\d\-_]+\$/ ) {
            my $tmp_extl = $expr;
            $tmp_extl =~ s/[^\.]+\.//g;
            $extl .= "\|$tmp_extl";
            $expr =~ s/\.[\w\d\-_]+\$//; 
        }
        # Append extensions upon checkboxes
        if ($all eq 'Y'){
            $extl = '|[a-z0-9_]+';
        }
        else{ 
            if($custom eq 'Y' && length($extl) != 0){
                $extl =~ s/[ \t\n\,\;]+/\|/  ;
                $extl = "\|" . $extl;
            }
            else{
                $extl .= '|exe|dll|com|ocx|bin|drv|sys' if ($win32 =~ 'Y');
                $extl .= '|arj|ain|arc|lha|rar|hqx|zip|cpz|tgz|gz|bz2|uc2|cab|tar' if ($arch =~ 'Y');
                $extl .= '|exe|zip|tar.gz|cab|tar.bz2|bin|sh|deb|rpm' if ($install =~ 'Y');
                $extl .= '|doc|rtf|txt|html|htm|htx|chi|chm' if ($doc =~ 'Y');
                $extl .= '|c|cc|cpp|cxx|h|hpp|java|jj|jack|pas|dpr|dfm|asm|asi|pl|sh|tcl|py|pm|l|y|lsp|4|bas|prg|rc|for|rh|idl|mdl' if ($src =~ 'Y');
                $extl .= '|avi|mpg|mpeg|mpeg2|dat|dv' if ($video =~ 'Y');
                $extl .= '|au|aiff|wav|raw|mp3|stm|s3m|xm|mod|mid|rmi|midi' if ($audio =~ 'Y');
                $extl .= '|htm|html|jsp|asp|asa|xtp|xsl|xml|dtd|xsd' if ($jsp =~ 'Y');
                $extl .= '|jpg|jpeg|xpm|xbm|bmp|tif|gif|png|pcx|wmf|eps|tiff' if ($imx =~ 'Y');
            }
        }

        if ($tlit eq 'Y') {
            
            if (open(SL,"/etc/zfsearch/translit.utf8")) {
                print "<!-- translit mode = ON -->\n";
                while(<SL>){ chomp;
                    if (substr($_,0,1) eq "#") {next;}
                    ($cyrchar, $translit)=split / /;
                    print "\t <!--readed : <$cyrchar->$translit> -->\n";
                    print "\t<!-- <$cyrchar->$translit> -->\n" if ($expr =~ /$cyrchar/ );
                    $expr =~ s/$cyrchar/($cyrchar|$translit)/g;
                }
                close(SL);
                print "<!-- translit mode = <$expr> -->\n";
            }
        }

        # crasy string concatenation to avoid nested substitution of \[wsd-] ;-)
        $dir_expr = "\^" . '[\w\s\d]*(' . $expr . ")[^\.]*\$";
        $expr = "($expr)[^\.]*\.(gz$extl)\$";
    }

    print "<!-- <$dir_expr>\n\t\t'directory search' mode\n -->\n" if ($s_dir_on == 1);
    print "<!-- <$expr>\n\t in [mode=$mode/$tlit,\n\t\tgroups={$win32,$arch,$install,$doc,$src,$video,$audio,$jsp,$img,$all},\n\t\t<$extl>]\n -->\n" if ($mode eq 'S');
    print "<!-- <$expr>\n\t in [mode=$mode/$tlit,\n\t\tgroups={$d_win32,$d_arch,$d_install,$d_doc,$d_video,$d_audio},\n\t\t<$extl>]\n -->\n" if ($mode eq 'E');
    print "<!-- <$expr> -->\n" if ($mode eq 'R');

    # Performing fast search in unique list of files
    my $found = 0;
    my $dir_found = 0;
    my $countf=0;
    my $countd=0;
    
    $first_ffile=$portion*$portion_size;
    $first_dfile=$portion*$portion_size;
    $last_ffile=$first_ffile+$portion_size-1;
    $last_dfile=$first_dfile+$portion_size-1;
    
    open (SB, zfsearch->DATADIR . "/unique-file-name") || die "No database file found in $file_path";
    while(<SB>){ chomp;
        if ( /$expr/io ){
            if ($countf>=$first_ffile && $countf<=$last_ffile) {
                $params{"file"}=$_;
                $result .= "\t<li><a href=\"/cgi-bin/search_files.pl?".zfsearch->query2str(\%params)."\">$_</a></li>\n";
            }
            $countf++;
        }
    }
    close(SB);
    if( $s_dir_on==1) {
        open (SB, zfsearch->DATADIR . "/unique-dir-name") || die "No database file found in $file_path";
        while (<SB>) { chomp;
            if ( /$dir_expr/io ){
                if ($countd>=$first_dfile && $countd<=$last_dfile) {
                    $params{"file"}=$_;
                    $dir_result .= "\t<li><a href=\"/cgi-bin/search_files.pl?".zfsearch->query2str(\%params)."\">$_</a></li>\n";
                }
                $countd++;
            }
        }
        close SB;
    }
    
    if ($countf>0 || $countd>0) {
        if ($last_ffile>$countf-1) {$last_ffile=$countf-1;}
        if ($last_dfile>$countd-1) {$last_dfile=$countd-1;}
        # output
        $first_ffile++; $first_dfile++;
        $last_ffile++; $last_dfile++;
        print "<table border=0 cellspacing=0 cellpadding=0>\n";
        if ($countd>0 && $last_dfile>=$first_dfile) {print "<tr><td width=40>&nbsp;</td><td>", zfsearch->gettext("directories"),"&nbsp;</td><td align=right>$first_dfile-$last_dfile ", zfsearch->gettext("of"), " $countd</td></tr>\n"}
        if ($countf>0 && $last_ffile>=$first_ffile) {print "<tr><td width=40>&nbsp;</td><td>", zfsearch->gettext("files"), "&nbsp;</td><td align=right>$first_ffile-$last_ffile ", zfsearch->gettext("of"), " $countf</td></tr>\n"} 
        print "</table>\n";
        
        zfsearch->put_paging($countf,$countd,$portion_size,$portion,\%params);
        
        # Content
        if($countd>0){
            print "<ul>\n$dir_result</ul>\n";
        }
        if ($countf>0) {
            print "<ul>\n$result</ul>\n";
        }

        zfsearch->put_paging($countf,$countd,$portion_size,$portion,\%params);
    } 
    else {
        print "<p>", zfsearch->gettext("try-again"), "</p>\n"
    }
    $tmsec=time-$begtime;
    printf zfsearch->gettext("timerefresh"),$tmsec;
} else {
    print "<p>", zfsearch->gettext("no-criteria"), "</p>\n";
}

zfsearch->put_skel_mode(zfsearch->SKELDIR,\%params);
zfsearch->put_bottom();
