#!/usr/bin/perl

use utf8;
use POSIX;
use CGI;
use zfsearch;

zfsearch->read_config();
zfsearch->setup_gettext($ENV{"HTTP_ACCEPT_LANGUAGE"});

my $req = new CGI;
zfsearch->parse_params($req,\%params);

zfsearch->put_top(\%params,1);

my $hcount=0,$fcount_all=0,$fsize_all=0;

open(S,zfsearch->DATADIR."/statistics") || die "No statistic file found";
    
print "<center><TABLE>\n";
print "<TR><td>Location</td><td width=60>Total files</td><td width=60>Total size</td></TR>\n";
while (<S>) { chomp;
    if (/^#/) {next}
    ($prot,$host,$fcount,$fsize)=split /:/;
    print "<TR>";
    print "<td>$prot:$host</td>";
    print "<td align=right>$fcount</td>";
    print "<td align=right>",putsize($fsize),"</td>";
    print "</TR>\n";
    $fcount_all+=$fcount;
    $fsize_all+=$fsize;
    $hcount++;
}
print "<tr><td colspan=3 bgcolor='#D2D2D2' height=1><img src=\"".zfsearch->HTTPPREFIX."/tr.gif\" width=\"1\" height=\"1\" alt=\"\"></td></tr>\n";
print "<TR>";
print "<td align=center>$hcount</td>";
print "<td align=right>$fcount_all</td>";
print "<td align=right>",putsize($fsize_all),"</td>";
print "</TR>\n";
print "</TABLE></center>\n";
close(S);

zfsearch->put_bottom();

sub putsize($) {
    my $sz=$_[0];
    if ($sz<900) {return "$sz bytes"}
    $sz/=1024;
    if ($sz<900) {return sprintf "%.1f K",$sz}
    $sz/=1024;
    if ($sz<900) {return sprintf "%.1f M",$sz}
    $sz/=1024;
    if ($sz<900) {return sprintf "%.1f G",$sz}
    $sz/=1024;
    return sprintf "%.1f T",$sz;
}
