#
# spec file for package zfsearch-spider (Version 1.1.0 )
# 
# Copyright (C) 2001-2002 Zaval Creative Engineering Group (http://www.zaval.org)
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# (version 2) as published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#

Vendor:       Zaval CE Group
Distribution: Linux
Name:         zfsearch-client
Packager:     support@zaval.org

License:      GPL
Group:        Network/Applications
Requires:     apache, perl
Autoreqprov:  on
Version:      1.3.0
Release:      1
Summary:      Zaval File Search
Source:       zfsearch-client-%{version}.tar.gz
URL:          http://www.zaval.org/products/file-search/
BuildRoot:    /usr/src/rpm/BUILD

%description
    The Zaval File Search solution is a local area network tool designed 
 for fast file search on SMB and FTP shares. It supports lots features 
 like regular expression usage and search based on custom/predefined 
 extensions.
    It was designed to provide easy and powerful indexing and search 
 facilities in corporate networks with SMB/MS/FTP shares. The similar 
 technologies are MS Indexing Service, and Napster-like tools.
    Unlike well-known solutions the Zaval File Search provide support for 
 small and medium networks(for 300-500 computers it works pretty fast) 
 and it does not require any database. The Zaval File Search spider 
 provides possibilities to do regular network scan and create indexes. 
 Another part of the product - Zaval File Search client, provides fast, 
 powerful and robust search facility over the files have indexed.
    Zaval File Search software has multi-tier client-server architecture, 
 where:
 1) Back-end of the Zaval File Search is spider which collects all 
 information asynchronously to all user requests;
 2) Server-side is couple of scripts to produce fast search capabilities 
 inside Apache web server;
 3) Client side is any browser that recognizes HTML 3.2 or later. CSS and 
 JavaScript support is optional;
    Default configuration contains its own virtual server (usually called 
 search.domain.com) with possibility to provide all available ways to 
 looking up information inside appropriate LAN or WAN.
    Product homepage: http://www.zaval.org/products/file-search/
    For any support questions mail us to support@zaval.org in a free form.

%prep
%setup -n zfsearch-client-%{version}

%build
make all

%install

make install
make install_docs

%files
/usr/lib/zfsearch/www/cgi-bin/*
/usr/lib/zfsearch/www/htdocs/*

%config
/etc/zfsearch/*

%doc
/usr/share/doc/zfsearch-client/*

%post
echo 'Please, include /etc/zfsearch/zfsearch-httpd.conf into /etc/httpd/httpd.conf'
